de.caff.generics.tuple

## Class ITuple4.Base<T1,T2,T3,T4>

- java.lang.Object
- - de.caff.generics.tuple.ITuple4.Base<T1,T2,T3,T4>

- Type Parameters:
    `T1` - type of first element
    `T2` - type of second element
    `T3` - type of third element
    `T4` - type of fourth element
  All Implemented Interfaces:
    ITuple4<T1,T2,T3,T4>
  Direct Known Subclasses:
    NTuple4, Tuple4
  Enclosing interface:
    ITuple4<T1,T2,T3,T4>

      public abstract static class ITuple4.Base<T1,T2,T3,T4>
      extends java.lang.Object
      implements ITuple4<T1,T2,T3,T4>

  Abstract base implementation of a 4-tuple. This provides standard implementations for `java.lang.Object` methods `equals()`, `hashCode()` and `toString()`. Therefore it is most useful if you implement a 4-tuple on the fly.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface de.caff.generics.tuple.ITuple4

      `ITuple4.Base<T1,T2,T3,T4>`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Base()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ITuple4.Base<T1,T2,T3,T4>` | `asBase()` Convert this 4-tuple into a `base tuple` which provides useful implementations for standard methods.
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `hashCode()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface de.caff.generics.tuple.ITuple4

      `_1, _12, _123, _124, _1243, _13, _132, _1324, _134, _1342, _14, _142, _1423, _143, _1432, _2, _21, _213, _2134, _214, _2143, _23, _231, _2314, _234, _2341, _24, _241, _2413, _243, _2431, _3, _31, _312, _3124, _314, _3142, _32, _321, _3214, _324, _3241, _34, _341, _3412, _342, _3421, _4, _41, _412, _4123, _413, _4132, _42, _421, _4213, _423, _4231, _43, _431, _4312, _432, _4321, concat1, concat2, concat3, concat4, concat5, concat6, concat7, concat8, concatPred1, concatPred2, concatPred3, concatPred4, concatPred5, concatPred6, concatPred7, concatPred8, concatProc1, concatProc2, concatProc3, concatProc4, concatProc5, concatProc6, concatProc7, concatProc8, equals, frozen, frozenNotNull, hash, invoke, sendTo, testBy, toString, toString, view`

- - ### Constructor Detail

    - #### Base

          public Base()

  - ### Method Detail

    - #### asBase

          @NotNull
          public ITuple4.Base<T1,T2,T3,T4> asBase()

      Description copied from interface: `ITuple4`
      Convert this 4-tuple into a `base tuple` which provides useful implementations for standard methods.
      Specified by:
        `asBase` in interface `ITuple4<T1,T2,T3,T4>`
      Returns:
        base view of this tuple

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`